#ifndef __bdos_impl_h__
#define __bdos_impl_h__

// $Id: bdos_impl.h,v 1.3 2011-04-07 23:54:04 drmiller Exp $
#include "z80_sys.h"
#include "bdos.h"

#define BDOS_DEFFCB	0x005c
#define BDOS_DEFDMA	0x0080
#define BDOS_START	0xfe00	// fictional "top of memory"
#define BIOS_START	0xff00	// fictional "top of memory"

typedef struct {
	uint16_t bc;      // BDOS function code
	uint16_t de;    // IN: DE
	uint16_t hl;    // OUT: HL
	uint8_t a;      // OUT: A
} bdos_params_t;

typedef int (bdos_func_t)(z80_sys_t *sys, bdos_params_t *parm);

extern bdos_func_t *bdos_funcs[256];

typedef int (bios_func_t)(z80_sys_t *sys, bdos_params_t *parm);

extern bios_func_t *bios_funcs[255/3];

extern void bdos_impl_init(z80_sys_t *sys);

#endif // __bdos_impl_h__
