#ifndef __z80_cpu_h__
#define __z80_cpu_h__

// $Id: z80_cpu.h,v 1.8 2011-04-06 21:44:04 drmiller Exp $
#include <stdio.h>
#include <stdint.h>

typedef union {
	uint16_t xx[3];
	uint8_t  gp[6];
} gp_bank_t;

enum {
	rp_BC = 0,
	rp_DE,
	rp_HL
};

// This is for get_gp() ONLY!
enum {
	gp_B = 0,
	gp_C,
	gp_D,
	gp_E,
	gp_H,
	gp_L
};

typedef union {
	uint16_t xx;
	uint8_t af[2];
} af_bank_t;

enum {
	af_F = 0,
	af_A
};

enum {
	ix_X = 0,
	ix_Y
};

typedef struct {
	gp_bank_t gp[2];
	uint8_t	gp_f;
} gp_regs_t;

typedef struct {
	af_bank_t af[2];
	uint8_t	af_f;
} psw_t;

typedef struct {
	gp_regs_t gp_regs;
	psw_t psw;

	uint16_t pc;
	uint16_t sp;
	uint16_t ix[2];
	uint8_t iv;
	uint8_t re;

	// --------------------

	uint8_t di;
	uint8_t intrq;
	uint8_t im;
	uint8_t iff1;
	uint8_t iff2;

	// --------------------

	uint64_t cycles;
} z80_cpu_t;

#if 0
/* bits in flags register */
#define Z80_F_S		10000000b
#define Z80_F_ZR	01000000b
/*			00100000b	*/
#define Z80_F_H		00010000b
/*			00001000b	*/
#define Z80_F_PV	00000100b
#define Z80_F_N		00000010b
#define Z80_F_CY	00000001b
#endif

typedef union {
	struct {
		uint8_t	psw_CY	:1;
		uint8_t	psw_NN	:1;
		uint8_t	psw_PV	:1;
		uint8_t	psw_3	:1;
		uint8_t	psw_HC	:1;
		uint8_t	psw_5	:1;
		uint8_t	psw_ZR	:1;
		uint8_t	psw_SG	:1;
	};
	uint8_t all;
} z80_psw_t;

#endif // __z80_cpu_h__
