// $Id: z80_decode.c,v 1.8 2011-04-03 17:23:52 drmiller Exp $

#include "z80_sys.h"
#include "z80_instr.h"
#include "z80_exec.h"

instr_t *primary[256] = {
[0000] = no_op_op,
[0020] = djnz_op,
[0030] = jr_op,
[0040] = jr_op,
[0050] = jr_op,
[0060] = jr_op,
[0070] = jr_op,

[0001] = lxi_op,
[0021] = lxi_op,
[0041] = lxi_op,
[0061] = lxi_op,

[0004] = inc_op,
[0014] = inc_op,
[0024] = inc_op,
[0034] = inc_op,
[0044] = inc_op,
[0054] = inc_op,
[0064] = inc_op,
[0074] = inc_op,

[0007] = rlc_op,
[0017] = rrc_op,
[0027] = ral_op,
[0037] = rar_op,
[0067] = scf_op,
[0077] = ccf_op,

[0005] = dec_op,
[0015] = dec_op,
[0025] = dec_op,
[0035] = dec_op,
[0045] = dec_op,
[0055] = dec_op,
[0065] = dec_op,
[0075] = dec_op,

[0003] = inx_op,
[0023] = inx_op,
[0043] = inx_op,
[0063] = inx_op,
[0013] = dcx_op,
[0033] = dcx_op,
[0053] = dcx_op,
[0073] = dcx_op,

[0006] = mvi_op,
[0016] = mvi_op,
[0026] = mvi_op,
[0036] = mvi_op,
[0046] = mvi_op,
[0056] = mvi_op,
[0066] = mvi_op,
[0076] = mvi_op,

[0047] = daa_op,
[0057] = cpl_op,

[0002] = stax_op,
[0022] = stax_op,
[0042] = shld_op,
[0062] = sta_op,

[0011] = dad_op,
[0031] = dad_op,
[0051] = dad_op,
[0071] = dad_op,

[0012] = ldax_op,
[0032] = ldax_op,
[0052] = lhld_op,
[0072] = lda_op,

[0100] = no_op_op,
[0101] = mov_op,
[0102] = mov_op,
[0103] = mov_op,
[0104] = mov_op,
[0105] = mov_op,
[0106] = mov_op,
[0107] = mov_op,

[0110] = mov_op,
[0111] = no_op_op,
[0112] = mov_op,
[0113] = mov_op,
[0114] = mov_op,
[0115] = mov_op,
[0116] = mov_op,
[0117] = mov_op,

[0120] = mov_op,
[0121] = mov_op,
[0122] = no_op_op,
[0123] = mov_op,
[0124] = mov_op,
[0125] = mov_op,
[0126] = mov_op,
[0127] = mov_op,

[0130] = mov_op,
[0131] = mov_op,
[0132] = mov_op,
[0133] = no_op_op,
[0134] = mov_op,
[0135] = mov_op,
[0136] = mov_op,
[0137] = mov_op,

[0140] = mov_op,
[0141] = mov_op,
[0142] = mov_op,
[0143] = mov_op,
[0144] = no_op_op,
[0145] = mov_op,
[0146] = mov_op,
[0147] = mov_op,

[0150] = mov_op,
[0151] = mov_op,
[0152] = mov_op,
[0153] = mov_op,
[0154] = mov_op,
[0155] = no_op_op,
[0156] = mov_op,
[0157] = mov_op,

[0160] = mov_op,
[0161] = mov_op,
[0162] = mov_op,
[0163] = mov_op,
[0164] = mov_op,
[0165] = mov_op,
[0166] = halt_op,
[0167] = mov_op,

[0170] = mov_op,
[0171] = mov_op,
[0172] = mov_op,
[0173] = mov_op,
[0174] = mov_op,
[0175] = mov_op,
[0176] = mov_op,
[0177] = no_op_op,

[0200] = add_op,
[0201] = add_op,
[0202] = add_op,
[0203] = add_op,
[0204] = add_op,
[0205] = add_op,
[0206] = add_op,
[0207] = add_op,

[0210] = adc_op,
[0211] = adc_op,
[0212] = adc_op,
[0213] = adc_op,
[0214] = adc_op,
[0215] = adc_op,
[0216] = adc_op,
[0217] = adc_op,

[0220] = sub_op,
[0221] = sub_op,
[0222] = sub_op,
[0223] = sub_op,
[0224] = sub_op,
[0225] = sub_op,
[0226] = sub_op,
[0227] = sub_op,

[0230] = sbb_op,
[0231] = sbb_op,
[0232] = sbb_op,
[0233] = sbb_op,
[0234] = sbb_op,
[0235] = sbb_op,
[0236] = sbb_op,
[0237] = sbb_op,

[0240] = and_op,
[0241] = and_op,
[0242] = and_op,
[0243] = and_op,
[0244] = and_op,
[0245] = and_op,
[0246] = and_op,
[0247] = and_op,

[0250] = xor_op,
[0251] = xor_op,
[0252] = xor_op,
[0253] = xor_op,
[0254] = xor_op,
[0255] = xor_op,
[0256] = xor_op,
[0257] = xor_op,

[0260] = or_op,
[0261] = or_op,
[0262] = or_op,
[0263] = or_op,
[0264] = or_op,
[0265] = or_op,
[0266] = or_op,
[0267] = or_op,

[0270] = cmp_op,
[0271] = cmp_op,
[0272] = cmp_op,
[0273] = cmp_op,
[0274] = cmp_op,
[0275] = cmp_op,
[0276] = cmp_op,
[0277] = cmp_op,

[0306] = addi_op,
[0316] = adci_op,
[0326] = subi_op,
[0336] = sbbi_op,
[0346] = andi_op,
[0356] = xori_op,
[0366] = ori_op,
[0376] = cmpi_op,

[0305] = push_op,
[0325] = push_op,
[0345] = push_op,
[0365] = push_op,

[0301] = pop_op,
[0321] = pop_op,
[0341] = pop_op,
[0361] = pop_op,

[0010] = exaf_op,
[0331] = exx_op,
[0353] = xchg_op,
[0343] = xthl_op,

[0363] = di_op,
[0373] = ei_op,

[0371] = sphl_op,

[0335] = opcode_DD,
[0313] = opcode_CB,
[0355] = opcode_ED,
[0375] = opcode_FD,

[0303] = jmp_op,
[0302] = jcc_op,
[0312] = jcc_op,
[0322] = jcc_op,
[0332] = jcc_op,
[0342] = jcc_op,
[0352] = jcc_op,
[0362] = jcc_op,
[0372] = jcc_op,

[0351] = pchl_op,

[0315] = call_op,
[0304] = ccc_op,
[0314] = ccc_op,
[0324] = ccc_op,
[0334] = ccc_op,
[0344] = ccc_op,
[0354] = ccc_op,
[0364] = ccc_op,
[0374] = ccc_op,

[0311] = ret_op,
[0300] = rcc_op,
[0310] = rcc_op,
[0320] = rcc_op,
[0330] = rcc_op,
[0340] = rcc_op,
[0350] = rcc_op,
[0360] = rcc_op,
[0370] = rcc_op,

[0307] = rst_op,
[0317] = rst_op,
[0327] = rst_op,
[0337] = rst_op,
[0347] = rst_op,
[0357] = rst_op,
[0367] = rst_op,
[0377] = rst_op,

[0333] = in_op,
[0323] = out_op,


};
