#ifndef __z80_exec_h__
#define __z80_exec_h__

// $Id: z80_exec.h,v 1.4 2011-04-03 17:22:21 drmiller Exp $
#include "z80_sys.h"

extern uint8_t fetch_opcode(z80_sys_t *sys, int off);
extern uint8_t fetch_imm8(z80_sys_t *sys, int off);
extern uint16_t fetch_imm16(z80_sys_t *sys, int off);
extern void ill_instr(z80_sys_t *sys);
extern void sys_exec(z80_sys_t *sys);
extern void opcode_CB(z80_sys_t *sys, uint8_t op1, uint16_t off);
extern void opcode_DD(z80_sys_t *sys, uint8_t op1, uint16_t off);
extern void opcode_ED(z80_sys_t *sys, uint8_t op1, uint16_t off);
extern void opcode_FD(z80_sys_t *sys, uint8_t op1, uint16_t off);
extern void opcode_DD_CB(z80_sys_t *sys, uint8_t op1, uint8_t op2, uint16_t off);	// also FD_CB...

// Select reg-pair 0-3 based on BC DE HL SP
extern uint16_t *get_rp(z80_sys_t *sys, int rp);

// Select reg-pair 0-3 based on BC DE HL AF - push/pop etc
extern uint16_t *get_rp2(z80_sys_t *sys, int rp);

// Select reg-pair 0-3 based on BC DE IX/IY SP
extern uint16_t *get_rp3(z80_sys_t *sys, int rp, int ix);

// Select reg 0-7 based on B C D E H L m A
extern uint8_t *get_gp(z80_sys_t *sys, int gp);

extern uint8_t *get_gp_A(z80_sys_t *sys);

extern z80_psw_t *get_gp_F(z80_sys_t *sys);

#endif // __z80_exec_h__
