#ifndef __z80_instr_h__
#define __z80_instr_h__

// one-byte opcode instructions
// $Id: z80_instr.h,v 1.4 2011-04-03 17:22:21 drmiller Exp $
#include "z80_decode.h"

// Standard 8080 instructions
extern void no_op_op(z80_sys_t *sys, uint8_t op1, uint16_t off);
extern void add_op(z80_sys_t *sys, uint8_t op1, uint16_t off);
extern void adc_op(z80_sys_t *sys, uint8_t op1, uint16_t off);
extern void sub_op(z80_sys_t *sys, uint8_t op1, uint16_t off);
extern void sbb_op(z80_sys_t *sys, uint8_t op1, uint16_t off);
extern void and_op(z80_sys_t *sys, uint8_t op1, uint16_t off);
extern void xor_op(z80_sys_t *sys, uint8_t op1, uint16_t off);
extern void or_op(z80_sys_t *sys, uint8_t op1, uint16_t off);
extern void cmp_op(z80_sys_t *sys, uint8_t op1, uint16_t off);
extern void inc_op(z80_sys_t *sys, uint8_t op1, uint16_t off);
extern void dec_op(z80_sys_t *sys, uint8_t op1, uint16_t off);
extern void dad_op(z80_sys_t *sys, uint8_t op1, uint16_t off);
extern void di_op(z80_sys_t *sys, uint8_t op1, uint16_t off);
extern void ei_op(z80_sys_t *sys, uint8_t op1, uint16_t off);
extern void mov_op(z80_sys_t *sys, uint8_t op1, uint16_t off);
extern void mvi_op(z80_sys_t *sys, uint8_t op1, uint16_t off);
extern void lxi_op(z80_sys_t *sys, uint8_t op1, uint16_t off);
extern void inx_op(z80_sys_t *sys, uint8_t op1, uint16_t off);
extern void dcx_op(z80_sys_t *sys, uint8_t op1, uint16_t off);
extern void ldax_op(z80_sys_t *sys, uint8_t op1, uint16_t off);
extern void stax_op(z80_sys_t *sys, uint8_t op1, uint16_t off);
extern void lda_op(z80_sys_t *sys, uint8_t op1, uint16_t off);
extern void sta_op(z80_sys_t *sys, uint8_t op1, uint16_t off);
extern void lhld_op(z80_sys_t *sys, uint8_t op1, uint16_t off);
extern void shld_op(z80_sys_t *sys, uint8_t op1, uint16_t off);
extern void xchg_op(z80_sys_t *sys, uint8_t op1, uint16_t off);
extern void xthl_op(z80_sys_t *sys, uint8_t op1, uint16_t off);
extern void cpl_op(z80_sys_t *sys, uint8_t op1, uint16_t off);
extern void ccf_op(z80_sys_t *sys, uint8_t op1, uint16_t off);
extern void scf_op(z80_sys_t *sys, uint8_t op1, uint16_t off);
extern void pchl_op(z80_sys_t *sys, uint8_t op1, uint16_t off);
extern void sphl_op(z80_sys_t *sys, uint8_t op1, uint16_t off);
extern void jmp_op(z80_sys_t *sys, uint8_t op1, uint16_t off);
extern void jcc_op(z80_sys_t *sys, uint8_t op1, uint16_t off);
extern void call_op(z80_sys_t *sys, uint8_t op1, uint16_t off);
extern void rst_op(z80_sys_t *sys, uint8_t op1, uint16_t off);
extern void ccc_op(z80_sys_t *sys, uint8_t op1, uint16_t off);
extern void push_op(z80_sys_t *sys, uint8_t op1, uint16_t off);
extern void pop_op(z80_sys_t *sys, uint8_t op1, uint16_t off);
extern void ret_op(z80_sys_t *sys, uint8_t op1, uint16_t off);
extern void rcc_op(z80_sys_t *sys, uint8_t op1, uint16_t off);
extern void in_op(z80_sys_t *sys, uint8_t op1, uint16_t off);
extern void out_op(z80_sys_t *sys, uint8_t op1, uint16_t off);
extern void halt_op(z80_sys_t *sys, uint8_t op1, uint16_t off);
extern void rlc_op(z80_sys_t *sys, uint8_t op1, uint16_t off);
extern void rrc_op(z80_sys_t *sys, uint8_t op1, uint16_t off);
extern void ral_op(z80_sys_t *sys, uint8_t op1, uint16_t off);
extern void rar_op(z80_sys_t *sys, uint8_t op1, uint16_t off);
extern void addi_op(z80_sys_t *sys, uint8_t op1, uint16_t off);
extern void adci_op(z80_sys_t *sys, uint8_t op1, uint16_t off);
extern void subi_op(z80_sys_t *sys, uint8_t op1, uint16_t off);
extern void sbbi_op(z80_sys_t *sys, uint8_t op1, uint16_t off);
extern void andi_op(z80_sys_t *sys, uint8_t op1, uint16_t off);
extern void xori_op(z80_sys_t *sys, uint8_t op1, uint16_t off);
extern void ori_op(z80_sys_t *sys, uint8_t op1, uint16_t off);
extern void cmpi_op(z80_sys_t *sys, uint8_t op1, uint16_t off);

// Z80 instructions
extern void jr_op(z80_sys_t *sys, uint8_t op1, uint16_t off);
extern void djnz_op(z80_sys_t *sys, uint8_t op1, uint16_t off);
extern void daa_op(z80_sys_t *sys, uint8_t op1, uint16_t off);
extern void exx_op(z80_sys_t *sys, uint8_t op1, uint16_t off);
extern void exaf_op(z80_sys_t *sys, uint8_t op1, uint16_t off);

#endif // __z80_instr_h__
