#ifndef __z80_instr2_h__
#define __z80_instr2_h__

// two-byte opcode instructions
// $Id: z80_instr2.h,v 1.5 2011-04-05 01:14:19 drmiller Exp $
#include "z80_decode2.h"

extern void bit_op(z80_sys_t *sys, uint8_t op1, uint8_t op2, uint16_t off);
extern void res_op(z80_sys_t *sys, uint8_t op1, uint8_t op2, uint16_t off);
extern void set_op(z80_sys_t *sys, uint8_t op1, uint8_t op2, uint16_t off);
extern void rlc_r_op(z80_sys_t *sys, uint8_t op1, uint8_t op2, uint16_t off);
extern void rrc_r_op(z80_sys_t *sys, uint8_t op1, uint8_t op2, uint16_t off);
extern void ral_r_op(z80_sys_t *sys, uint8_t op1, uint8_t op2, uint16_t off);
extern void rar_r_op(z80_sys_t *sys, uint8_t op1, uint8_t op2, uint16_t off);
extern void sla_r_op(z80_sys_t *sys, uint8_t op1, uint8_t op2, uint16_t off);
extern void sra_r_op(z80_sys_t *sys, uint8_t op1, uint8_t op2, uint16_t off);
extern void srl_r_op(z80_sys_t *sys, uint8_t op1, uint8_t op2, uint16_t off);
extern void inc_ix_op(z80_sys_t *sys, uint8_t op1, uint8_t op2, uint16_t off);
extern void dec_ix_op(z80_sys_t *sys, uint8_t op1, uint8_t op2, uint16_t off);
extern void inx_ix_op(z80_sys_t *sys, uint8_t op1, uint8_t op2, uint16_t off);
extern void dcx_ix_op(z80_sys_t *sys, uint8_t op1, uint8_t op2, uint16_t off);
extern void dad_ix_op(z80_sys_t *sys, uint8_t op1, uint8_t op2, uint16_t off);
extern void mvi_ix_op(z80_sys_t *sys, uint8_t op1, uint8_t op2, uint16_t off);
extern void lxi_ix_op(z80_sys_t *sys, uint8_t op1, uint8_t op2, uint16_t off);
extern void lixd_op(z80_sys_t *sys, uint8_t op1, uint8_t op2, uint16_t off);
extern void sixd_op(z80_sys_t *sys, uint8_t op1, uint8_t op2, uint16_t off);
extern void mov_ix_op(z80_sys_t *sys, uint8_t op1, uint8_t op2, uint16_t off);
extern void add_ix_op(z80_sys_t *sys, uint8_t op1, uint8_t op2, uint16_t off);
extern void adc_ix_op(z80_sys_t *sys, uint8_t op1, uint8_t op2, uint16_t off);
extern void sub_ix_op(z80_sys_t *sys, uint8_t op1, uint8_t op2, uint16_t off);
extern void sbb_ix_op(z80_sys_t *sys, uint8_t op1, uint8_t op2, uint16_t off);
extern void and_ix_op(z80_sys_t *sys, uint8_t op1, uint8_t op2, uint16_t off);
extern void xor_ix_op(z80_sys_t *sys, uint8_t op1, uint8_t op2, uint16_t off);
extern void or_ix_op(z80_sys_t *sys, uint8_t op1, uint8_t op2, uint16_t off);
extern void cmp_ix_op(z80_sys_t *sys, uint8_t op1, uint8_t op2, uint16_t off);
extern void pop_ix_op(z80_sys_t *sys, uint8_t op1, uint8_t op2, uint16_t off);
extern void push_ix_op(z80_sys_t *sys, uint8_t op1, uint8_t op2, uint16_t off);
extern void spix_op(z80_sys_t *sys, uint8_t op1, uint8_t op2, uint16_t off);
extern void xtix_op(z80_sys_t *sys, uint8_t op1, uint8_t op2, uint16_t off);
extern void pcix_op(z80_sys_t *sys, uint8_t op1, uint8_t op2, uint16_t off);
extern void in_r_op(z80_sys_t *sys, uint8_t op1, uint8_t op2, uint16_t off);
extern void out_r_op(z80_sys_t *sys, uint8_t op1, uint8_t op2, uint16_t off);
extern void reti_op(z80_sys_t *sys, uint8_t op1, uint8_t op2, uint16_t off);
extern void retn_op(z80_sys_t *sys, uint8_t op1, uint8_t op2, uint16_t off);
extern void dadc_op(z80_sys_t *sys, uint8_t op1, uint8_t op2, uint16_t off);
extern void dsbc_op(z80_sys_t *sys, uint8_t op1, uint8_t op2, uint16_t off);
extern void neg_op(z80_sys_t *sys, uint8_t op1, uint8_t op2, uint16_t off);
extern void im0_op(z80_sys_t *sys, uint8_t op1, uint8_t op2, uint16_t off);
extern void im1_op(z80_sys_t *sys, uint8_t op1, uint8_t op2, uint16_t off);
extern void im2_op(z80_sys_t *sys, uint8_t op1, uint8_t op2, uint16_t off);
extern void rrd_op(z80_sys_t *sys, uint8_t op1, uint8_t op2, uint16_t off);
extern void rld_op(z80_sys_t *sys, uint8_t op1, uint8_t op2, uint16_t off);
extern void mov_i_op(z80_sys_t *sys, uint8_t op1, uint8_t op2, uint16_t off);
extern void mov_r_op(z80_sys_t *sys, uint8_t op1, uint8_t op2, uint16_t off);
extern void sxxd_op(z80_sys_t *sys, uint8_t op1, uint8_t op2, uint16_t off);
extern void lxxd_op(z80_sys_t *sys, uint8_t op1, uint8_t op2, uint16_t off);
extern void ldi_op(z80_sys_t *sys, uint8_t op1, uint8_t op2, uint16_t off);
extern void cpi_op(z80_sys_t *sys, uint8_t op1, uint8_t op2, uint16_t off);
extern void ldd_op(z80_sys_t *sys, uint8_t op1, uint8_t op2, uint16_t off);
extern void cpd_op(z80_sys_t *sys, uint8_t op1, uint8_t op2, uint16_t off);
extern void ldir_op(z80_sys_t *sys, uint8_t op1, uint8_t op2, uint16_t off);
extern void cpir_op(z80_sys_t *sys, uint8_t op1, uint8_t op2, uint16_t off);
extern void lddr_op(z80_sys_t *sys, uint8_t op1, uint8_t op2, uint16_t off);
extern void cpdr_op(z80_sys_t *sys, uint8_t op1, uint8_t op2, uint16_t off);
extern void ini_op(z80_sys_t *sys, uint8_t op1, uint8_t op2, uint16_t off);
extern void ind_op(z80_sys_t *sys, uint8_t op1, uint8_t op2, uint16_t off);
extern void inir_op(z80_sys_t *sys, uint8_t op1, uint8_t op2, uint16_t off);
extern void indr_op(z80_sys_t *sys, uint8_t op1, uint8_t op2, uint16_t off);
extern void outi_op(z80_sys_t *sys, uint8_t op1, uint8_t op2, uint16_t off);
extern void outd_op(z80_sys_t *sys, uint8_t op1, uint8_t op2, uint16_t off);
extern void outir_op(z80_sys_t *sys, uint8_t op1, uint8_t op2, uint16_t off);
extern void outdr_op(z80_sys_t *sys, uint8_t op1, uint8_t op2, uint16_t off);

#endif // __z80_instr2_h__
