// $Id: z80_io.c,v 1.3 2011-04-03 17:23:52 drmiller Exp $

#include <stdio.h>
#include "z80_io.h"

static z80_dev_t *find_port(z80_io_t *io, uint8_t port) {
	z80_dev_t *d;
	d = io->io_devs[port];
	if (!d) {
		io->iofault(io->sys, port);
	}
	return d;
}
extern void io_init(z80_io_t *io, uint8_t base, uint8_t len, z80_dev_t *dev) {
	uint8_t p;
	for (p = base; p < base + len; ++p) {
		if (io->io_devs[p]) {
			fprintf(stderr, "WARNING: overlapping I/O port at %02x\n", p);
		}
		io->io_devs[p] = dev;
	}
}
extern void io_output(z80_io_t *io, uint8_t port, uint8_t *buf, uint8_t len) {
	z80_dev_t *d;
	d = find_port(io, port);
	d->output(d, port, buf, len);
}
extern void io_input(z80_io_t *io, uint8_t port, uint8_t *buf, uint8_t len) {
	z80_dev_t *d;
	d = find_port(io, port);
	d->input(d, port, buf, len);
}
