#ifndef __z80_mem_h__
#define __z80_mem_h__

// $Id: z80_mem.h,v 1.4 2011-04-03 17:22:21 drmiller Exp $
#include <stdint.h>

typedef struct mem_map_s {
	uint8_t *mem;
	uint32_t padr;
	uint16_t vadr;
	uint32_t len;
	char *src;
	struct mem_map_s *next;
} mem_map_t;

typedef struct {
	mem_map_t *maps;
	mem_map_t *mmu[256];
	void (*segfault)(void *sys, uint16_t adr);
	void *sys;
} z80_mem_t;

extern void mem_init(z80_mem_t *mem, uint32_t padr, uint16_t vadr, uint32_t len,
							char *src, uint16_t sadr);
extern void mem_mmu_map(z80_mem_t *mem, uint32_t adr, uint32_t len);

extern uint8_t *mem_get_addr(z80_mem_t *mem, uint16_t adr);
extern uint8_t mem_get_byte(z80_mem_t *mem, uint16_t adr);
extern uint16_t mem_get_word(z80_mem_t *mem, uint16_t adr);

#endif // __z80_mem_h__
