#ifndef __z80_sys_h__
#define __z80_sys_h__

// $Id: z80_sys.h,v 1.10 2011-04-08 23:11:31 drmiller Exp $

#define TRACE

#define USE_BDOS

#ifdef TRACE
#include <stdio.h>
#endif // TRACE

#include "z80_cpu.h"
#include "z80_io.h"
#include "z80_mem.h"

typedef struct z80_sys_s {
	z80_cpu_t cpu;
	z80_mem_t mem;
	z80_io_t io;
	void (*fault)(struct z80_sys_s *sys, const char *str);
	int (*intr)(struct z80_sys_s *sys, int sig);	// return != 0 if signal not handled
	int run;
#ifdef TRACE
	int trace;
	FILE *trc_fp;
#endif // TRACE
#ifdef USE_BDOS
	uint8_t *ccp;
	uint16_t ccp_len;
	uint16_t ccp_adr;
	uint16_t ccp_ent;
#endif // USE_BDOS
} z80_sys_t;

extern void sys_init(z80_sys_t *sys);
extern void sys_loadpgm(z80_sys_t *sys, char *exe, uint16_t adr, uint16_t entry);
extern void sys_go(z80_sys_t *sys, uint16_t entry);
#ifdef USE_BDOS
extern void sys_setccp(z80_sys_t *sys, char *exe, uint16_t adr, uint16_t entry);
void sys_runccp(z80_sys_t *sys);
#endif // USE_BDOS

#endif // __z80_sys_h__
